/* aircollect.c
   KoreK
   Licence: still GPLv2 or above

   gutted aircrack into an iv collector for chopper
*/


/*
 *  802.11 40/104 bit WEP Key Cracker
 *
 *  Copyright (C) 2004  Christophe Devine
 *
 *  Advanced WEP attacks developped by KoreK
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <sys/ioctl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>

#include "pcap.h"

#define AMOD(x,y) ((x) % (y) < 0 ? ((x) % (y)) + (y) : (x) % (y))
#define SWAP(x,y) { unsigned char tmp = x; x = y; y = tmp; }

#define SUCCESS 0
#define FAILURE 1

char usage[] =

"\n"
"  aircollect - collects IVs into a chopper compatible file\n"
"  based on aircrack 1.2 - (C) 2004 Christophe Devine\n"
"\n"
"  usage: %s [options] <pcap filename(s)>\n"
"\n"
"      -b <bssid> : identifier of the network to crack\n"
"      -k <keyid> : Key ID between 0 and 3\n"
"\n";

/* command-line parameters */

int bssid_set = 0;              /* check flag   */
unsigned char bssid[6];         /* AP's BSSID   */
int keyid  = 0;                 /* WEP KeyID    */

// output filename is ESSID.keyid, eg aa:bb:cc:dd:ee:ff.0 
char output[20];
FILE *fc;
/* runtime global data */

unsigned char buffer[65536];    /* buffer for reading packets   */

unsigned char *ivbuf;           /* buffer for the unique IVs    */
unsigned long nb_ivs;           /* number of elements in ivbuf  */
char *test_unique_ivs;          /* to avoid adding duplicates   */
int magic=0x4d3c0f10;

int read_ivs( char *filename );


int main( int argc, char *argv[] )
{
    char *s;
    int i;

    /* check the arguments */

    if( argc < 2 )
    {
    usage:
        printf( usage, argv[0] );
        return( FAILURE );
    }

    while( 1 )
    {
        int option = getopt( argc, argv, "b:k:" );

        if( option < 0 ) break;

        switch( option )
        {
            case 'b':
                s = optarg;
		{
		    unsigned int mac[6];
		    char last;
		    i=sscanf(s," %2x:%2x:%2x:%2x:%2x:%2x %c",
			     mac,mac+1,mac+2,mac+3,mac+4,mac+5,&last);
		    if (i!=6) goto usage;
		    for (i=0;i<6;i++) bssid[i]=mac[i];
		    bssid_set = 1;
		}
                break;


	    case 'k':
		s = optarg;
		{
		    char last;
		    i=sscanf(s," %1d %c",&keyid,&last);
		    if ((i != 1) || (keyid<0) || (keyid>3)) goto usage;
		}
		break;
		

            default : 
		goto usage;
        }
    }

    if( ! ( argc - optind ) )  goto usage;

    if ( ! bssid_set ) goto usage; 

    /* initialize all the data */

    nb_ivs = 0;

    if( ! ( ivbuf = (unsigned char *)
                        malloc( 5 * 256 * 256 * 256 ) ) )
    {
        perror( "malloc" );
        return( FAILURE );
    }

    if( ! ( test_unique_ivs = (char *)
                                malloc( 256 * 256 * 256 ) ) )
    {
        perror( "malloc" );
        return( FAILURE );
    }

    memset( test_unique_ivs, 0, 256 * 256 * 256 );

    /* read the packets from each file */

    while( optind != argc )
    {
        if( read_ivs( argv[optind] ) != SUCCESS )
            return( FAILURE );

        optind++;
    }

    free( test_unique_ivs );

    snprintf(output,20,"%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx.%1d",
	     bssid[0],bssid[1],bssid[2],bssid[3],bssid[4],bssid[5],keyid);
    output[19]=0;

    fc=fopen(output,"w");
    if (fwrite(&magic,4,1,fc) != 1) return FAILURE;

    if (fwrite(ivbuf,5,nb_ivs,fc) != 1) return FAILURE;

    fclose(fc);

    return( SUCCESS );
}

int read_ivs( char *filename )
{
    int i, n, infile;
    unsigned long cnt1;
    unsigned long cnt2;
    unsigned char *h80211;
    struct pcap_pkthdr pkh;
    struct pcap_file_header pfh;

    /* open the file and check the pcap header */

    printf( "Opening pcap file %s\n", filename );

    if( ( infile = open( filename, O_RDONLY | O_LARGEFILE ) ) < 0 )
    {
        perror( "open" );
        return( FAILURE );
    }

    n = sizeof( struct pcap_file_header );

    if( read( infile, &pfh, n ) != n )
    {
        perror( "read" );
        return( FAILURE );
    }

    if( pfh.magic != TCPDUMP_MAGIC )
    {
        fprintf( stderr, "wrong magic from pcap file header\n"
                         "(got 0x%08X, expected 0x%08X)\n",
                         pfh.magic, TCPDUMP_MAGIC );
        return( FAILURE );
    }

    if( pfh.linktype != LINKTYPE_IEEE802_11 &&
        pfh.linktype != LINKTYPE_PRISM_HEADER )
    {
        fprintf( stderr, "unsupported pcap header linktype %d\n",
                 pfh.linktype );
        return( FAILURE );
    }


    cnt1 = cnt2 = 0;

    while( 1 )
    {
        /* read one packet */

        n = sizeof( pkh );

        if( read( infile, &pkh, n ) != n )
            break;

        n = pkh.len;

        if( read( infile, buffer, n ) != n )
            break;

        cnt1++;

        h80211 = buffer;

        if( pfh.linktype == LINKTYPE_PRISM_HEADER )
        {
            /* remove the prism header if necessary */

            n = *(int *)( h80211 + 4 );
            h80211 += n; pkh.len -= n;

            if( pkh.len <= 0 )
            {
                fprintf( stderr, "\nFIXME: wrong prism header size ?\n" );
                continue;
            }
        }

        /* minimum encrypted data packet size: 40 = 24  *
         * (802.11) + 4 (IV, KeyID) + 8 (LLC) + 4 (FCS) */

        if( pkh.len < 40 ) continue;

        /* is it an encrypted data packet ? */

        if( ( h80211[0] & 0x0C ) != 0x08 ) continue;
        if( ( h80211[1] & 0x40 ) != 0x40 ) continue;

        /* is it the correct keyid ? */

        if( ( h80211[27] >> 6 ) != keyid ) continue;

        /* check if the bssids match */

        switch( h80211[1] & 3 )
        {
            case  0: i = 16; break;      /* DA, SA, BSSID  */
            case  1: i =  4; break;      /* BSSID, SA, DA  */
            case  2: i = 10; break;      /* DA, BSSID, SA  */
            default: i =  4; break;      /* RA, TA, DA, SA */
        }

        if( ! bssid_set )
        {
            memcpy( bssid, h80211 + i, 6 );

            printf( "\33[2KChoosing first encrypted BSSID"
                    " = %02X:%02X:%02X:%02X:%02X:%02X\n",
                    bssid[0], bssid[1], bssid[2],
                    bssid[3], bssid[4], bssid[5] );

            bssid_set = 1;
        }
        else
            if( memcmp( bssid, h80211 + i, 6 ) )                continue;

        /* have we already seen this IV ? */

        n = ( h80211[24] << 16 )
          | ( h80211[25] <<  8 )
          | ( h80211[26]       );

        if( test_unique_ivs[n] ) continue;

        test_unique_ivs[n] = 1;


        /* might be a weak IV for keybyte B, so add it */

        ivbuf[nb_ivs * 5    ] = h80211[24];
        ivbuf[nb_ivs * 5 + 1] = h80211[25];
        ivbuf[nb_ivs * 5 + 2] = h80211[26];

        /* also add the first two byte of RC4's output */

        ivbuf[nb_ivs * 5 + 3] = h80211[28] ; // ^ 0xAA;
        ivbuf[nb_ivs * 5 + 4] = h80211[29] ; // ^ 0xAA;

        cnt2++; nb_ivs++;
    }

    printf( "\r\33[2KReading packets: total = %ld"
            ", usable = %ld.\n", cnt1, cnt2 );

    return( SUCCESS );
}
