/* chopper.c
   cracker file
   now includes main but should be removed

   Author : KoreK
   Date : Mar 8, 2004
   Licence : GPL v2 or above (see accompanying LICENSE file)
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define NDEBUG 
#include <assert.h>

#include "wep_data.h"
#include "gen.h"
#include "chopper.h"


int main(int argv,char **argc)
{

    wep_data_t w;

    int dpth,heapsize;

    guess_cnt_t gc;
    guess_stat_t gs;
    struct key K0[1];

    struct heap_key *oldh,*curh;
    size_t klen,cnt;
    int argp,succ;


    heapsize=512;
    dpth=0;

    oldh=calloc(1,sizeof *oldh);
    curh=calloc(1,sizeof *curh);
    oldh->max_size=heapsize;
    curh->max_size=heapsize;

    print_constants();

    succ=0;

    init_wepdata(w,0,0,0,0,0);

    for (argp=1; argp<argv;argp++) {
	size_t i,clen;
	struct key *K;
	int match=0;

	fprintf(stderr,"%d/%d\n",succ,argp-1);
        fprintf(stderr,"%s\n",argc[argp]);
	
	if (read_wep(w,argc[argp])!=0) {
	    fprintf(stderr,"Could not read file %s\n",argc[argp]);
	    return -1;
	}

	for (i=0;i<w->key_len;i++) K0->K[i]=w->key[i];
	K0->klen=w->key_len;
	K0->clen=K0->klen;
	K0->gr=0.0f;
	print_key(stdout,"Key : %k (%l)\n\n",K0);

	if (K0->klen==0) klen=13;
	else klen=K0->klen;

	curh->s=1; 
	curh->idx[1]=1; 
	memcpy(curh->k+1,K0,sizeof *K0); 
	(curh->k+1)->clen=dpth;
	(curh->k+1)->klen=klen;


	for (clen=dpth; clen<(2*klen-1); clen++) {
	    swap_heaps(&curh,&oldh);

	    if (clen==klen) {
		for (i=1; i<=oldh->s; i++) {
		    (oldh->k+oldh->idx[i])->gr=0;
		}
	    }

	    for (i=1; i<=oldh->s; i++) {
		K=oldh->k+oldh->idx[i];
		reset_guess(gc);
		if (clen!=klen-1) plain_attack(w,K,gc);
		else attack_last(w,K,gc);
		est_guess(K,gc,gs);
		adj_guess(gs);
		insert_grade(curh,K,gs);
	    }
	    printf("s: %u\n",curh->s);
	    fflush(stdout);

	    heapsort(curh);
	    truncate_heap(curh);
	    rank_heap(curh);



	    inc_clen(curh);
	    print_key(stdout,"%K : Key\n",K0);
	    print_heap(stdout,curh);

	    if (clen>=klen) remove_heap_dup(curh);

	    printf("\n");

	    fflush(stdout);

	    if (clen>=(klen-1)) {
		Grade chk;

		for (i=1; i<=curh->s; i++) { 
		    K=curh->k+curh->idx[i];
		    chk=check_key(w,K,256);
		    if (chk>0.1f) {
			print_key(stdout,"Match key: %k ",K);
			printf("(%f)\n",(double )chk);
			if (chk>0.5f) match=1;
		    }
		}
		if (match) break;
	    }
 	    if (curh->s==0) break;
	}
	fflush(stdout);		    
	if (match) {
	    succ++;
	    continue;
	}
	if (curh->s==0) {
	    printf("Failed .... \n");
	    continue;
	}

	set_clen(curh,klen);

	for (clen=klen,cnt=0; cnt<2; clen++) {
	    if (clen == 2*klen-1) {
		clen=klen;
		cnt++;
		set_clen(curh,klen);
	    }
	    /* do your stuff */
	    swap_heaps(&curh,&oldh);

	    for (i=1; i<=oldh->s; i++) {
		K=oldh->k+oldh->idx[i];
		reset_guess(gc);
		plain_attack(w,K,gc);
		est_guess(K,gc,gs);
		adj_guess(gs);
		insert_grade(curh,K,gs);
	    }
	    printf("s: %u\n",curh->s);
	    fflush(stdout);

	    heapsort(curh);

	    truncate_heap(curh);
	    rank_heap(curh);

	    inc_clen(curh);
	    print_key(stdout,"%K : Key\n",K0);
	    print_heap(stdout,curh);

	    remove_heap_dup(curh);

	    printf("\n");

	    fflush(stdout);

	    if (clen>=(klen-1)) {
		Grade chk;

		for (i=1; i<=curh->s; i++) { 
		    K=curh->k+curh->idx[i];
		    chk=check_key(w,K,256);
		    if (chk>0.1f) {
			print_key(stdout,"Match key: %k ",K);
			printf("(%f)\n",(double )chk);
			if (chk>0.5f) match=1;
		    }
		}
		if (match) break;
	    }
	    if (curh->s==0) break;
	}

	if (match) succ++;
	else printf("Failed .... \n");
	fflush(stdout);
    }

    printf("\n\n%d/%d\n",succ,argp-1);



    delete_wepdata(w);

    return 0;
}


void print_constants()
{
    printf("RANK_MUL_COEFF = %f\n"
	   "DIFF_KEY_COEFF = %f\n"
	   "DIV_F = %f\n"
	   "TRUNC = %u\n"
	   "CULL_COEFF = %f\n",
	   RANK_MUL_COEFF,
	   DIFF_KEY_COEFF,
	   DIV_F,
	   TRUNC,
	   CULL_COEFF);

    return;
}



/* Heap functions:
   - heapsort: the sort the min-heap in decreasing order.
   - insertnewkey: insert an element in the heap (if there is some room left)
   - deletekey: to be implemented...
   - print_heap: print a heap
   - swap_heaps: swap two heaps (to get rid of ?)
   - remove_heap_dup : remove duplicate on a heapsort'ed struct heap_key
*/

void swap_heap_el(struct heap_key *H,size_t i,size_t j)
{
    size_t *idx;
    size_t sw;
    
    assert((i<=H->s) && (j<=H->s));
    idx=H->idx;
    sw=idx[i];
    idx[i]=idx[j];
    idx[j]=sw;
}

/* heapify down from position i>0 with a heap_key of size s 
   Element bubbles down till it's greater than its parent */
void heapify_down(struct heap_key *H,size_t i,size_t s)
{
    size_t p,l,r,min;
    struct key *k;
    size_t *idx;
    Grade gr_l,gr_p,gr_r;
    
    assert((i<=H->s) && (s<=H->s));

    k=H->k;
    idx=H->idx;

    p=i;
    l=p << 1;
    r=l+1;
    while (r<=s) {
	/* we got 3 elements */
	gr_p=(k+idx[p])->gr;
	gr_l=(k+idx[l])->gr;
	gr_r=(k+idx[r])->gr;
	min = (gr_l < gr_r) ? l : r;
	if (gr_p < (k+idx[min])->gr) break; 
	swap_heap_el(H,p,min);
	p=min;
	l=p << 1;
	r=l+1;
    }
    if (l==s) {
	/* we got 2 elements and none after */
	gr_p=(k+idx[p])->gr;
	gr_l=(k+idx[l])->gr;
	if (gr_l < gr_p) {
	    swap_heap_el(H,p,l);
	}
    }	
}    

/* remove dups from a heap
   assume heap is non-empty/all key have the same klen, element 0 of the heap
   is null/non-existent
   if klen=0, then nothing happens */
void remove_heap_dup(struct heap_key *H)
{
    size_t i,j,ki;
    struct key *k,*k1,*k2;
    size_t s,klen,*idx;

    s=H->s;
    k=H->k;
    idx=H->idx;

    klen=(k+idx[1])->klen;

    for (i=s; i>1; i--) {
	k1=k+idx[i];
	for (j=i-1; j>=1; j--) {
	    k2=k+idx[j];
	    for (ki=0; (ki<klen) && (k1->K[ki]==k2->K[ki]); ki++);
	    if (ki==klen) {
		H->idx[i]=0;
		break;
	    }
	}
    }
    
    for (i=2,j=2; j<=s; j++) {
	if (idx[j]!=0) {
	    if (i!=j) idx[i]=idx[j];
	    i++;
	}
	else {
	    H->s--;
	}
    }
    printf("removed %d dup\n",s-H->s);

}


/* heapify up from position i (no need for s, top is always 1)
   Element bubbles up until it's greater than its parent */
void heapify_up(struct heap_key *H,size_t i)
{
    size_t p;
    size_t *idx;
    struct key *k;
    Grade gr_p,gr_i;
    
    assert((i<=H->s) && (i!=0));
    
    k=H->k;
    idx=H->idx;
    
    gr_i=(k+idx[i])->gr;
    while (i>1) {
	p=i >> 1;
	gr_p=(k+idx[p])->gr;
	if (gr_i < gr_p) {
	    swap_heap_el(H,i,p);
	    i=p;
	    gr_i=gr_p;
	}
	else break;
    }
}


void heapsort(struct heap_key *H)
{
    size_t s,*idx;

    s=H->s;
    idx=H->idx;
    while (s>1) {
	swap_heap_el(H,1,s);
	heapify_down(H,1,--s);
    }
}


/* Add a certain grade according to the rank
   linear function to start */
void rank_heap(struct heap_key *H)
{
    size_t t0,t1,t,s;
    Grade gr0,gr;
    struct key *k;
    size_t *idx;
    
    k=H->k;
    idx=H->idx;
    s=H->s;

    if (s>1) {
	t1=1;
	while (t1<=s) {
	    t0=t1;
	    gr0=(k+idx[t0])->gr;
	    do {
		t1++;
	    } while ((t1<=s) && ((k+idx[t1])->gr==gr0));
	    /* grade [t0,t1[ with a note in [0..1] */
	    gr=(1.0f-(t0+t1-3.0f)/(2.0f*(s-1)))*RANK_MUL_COEFF;
	    for (t=t0; t<t1; t++) (k+idx[t])->gr+=gr;
	};
    }
}

/* truncate a sorted heap leaving at least trunc elements */
void truncate_heap(struct heap_key *H)
{
    size_t i,s;
    struct key *k;
    size_t *idx;
    Grade br;

    k=H->k;
    idx=H->idx;
    s=H->s;
    if (s>1) {
	br=(k+idx[1])->gr*CULL_COEFF;
	i=TRUNC<s ? TRUNC : s;
	if ( (k+idx[i])->gr < br) {
	    while ((k+idx[--i])->gr <br);
	    H->s=i;
	}
	else if (i<s) {
	    br=(k+idx[i])->gr;
	    do i++; while ((i<=s) && ((k+idx[i])->gr>=br));
	    H->s=i-1;
	}
    }
    return;
}


void cull_heap(struct heap_key *H)
{
    /* culling will have to be done later on */
    return;
}


/* Insert the key K into the heap H */
void insertnewkey(struct heap_key *H,const struct key *K)
{
    struct key *k;
    size_t *idx,s;
    
    s=H->s;
    k=H->k;
    idx=H->idx;

    if (s < H->max_size) {
        /* insert at the end */	
	s=++H->s;
	idx[s]=s;
	memcpy(k+s,K,sizeof *K);
        /* reheapify from the end */
	heapify_up(H,s);
    }
    else if ((k+idx[1])->gr < K->gr) {
	/* overwrite old min */
	memcpy(k+idx[1],K,sizeof *K);
 	/* reheapify */
	heapify_down(H,1,s);
    }
}

/* insert positive grade into the heap, mixing them with the previous grade */
void insert_grade(struct heap_key *H,const struct key *oldK,
		  const guess_stat_t g)
{
    size_t i,c,clen,klen;
    Grade grK;
    struct key K[1];
    
    memcpy(K,oldK,sizeof *K);
    grK=K->gr;
    clen=K->clen;
    klen=K->klen;

    if (klen!=0) c=clen % klen;
    else c=clen;
    

    for (i=0; i<256; i++) {
	if (g[i]>=0.0f) {
	    K->gr=g[i]+grK*FEEDBACK;
	    if ((c!=clen) && (c!=(klen-1))) {
		K->K[c+1]=K->K[c+1]+K->K[c]-i;
	    }
	    K->K[c]=i;
	    insertnewkey(H,K);
	}
    }
}

void inc_clen(struct heap_key *H)
{
    size_t i,s,*idx;
    struct key *k;

    s=H->s;
    k=H->k;
    idx=H->idx;
    for (i=1; i<=s; i++) (k+idx[i])->clen++;
}

void set_clen(struct heap_key *H,size_t clen)
{
    size_t i,s,*idx;
    struct key *k;

    s=H->s;
    k=H->k;
    idx=H->idx;
    for (i=1; i<=s; i++) (k+idx[i])->clen=clen;
}


/* swap c and o, reset c */
void swap_heaps(struct heap_key **c,struct heap_key **o)
{
    struct heap_key *sw;

    sw=*o;
    *o=*c;
    *c=sw;
    sw->s=0;
}


void print_heap(FILE *stream,struct heap_key *H)
{
    size_t i;
    struct key *k;

    for (i=1; i<=H->s; i++) {
	k=H->k+H->idx[i];
	print_key(stream,"%K : %g (%c:%l)\n",k);
    }
}



/* struct key functions */
void print_key(FILE *stream,const char *format,const struct key *k)
{
    const char *s0,*s;
    u_char tot;
    int i,klen;

    if (k->klen!=0) {
	klen=k->clen < k->klen ? k->clen : k->klen;
    }
    else klen=k->clen;

    s0=format;
    for (s=s0; *s!=0; s++) {
	if (*s=='%') {
	    s++;
	    if (*s=='%') {
		fwrite(s0,s-s0,1,stream);
		s0=s+1;
	    }
	    else {
		fwrite(s0,s-s0-1,1,stream);
		s0=s+1;
		switch (*s) {
		    case 'k' : //key
			if (klen) {
			    for (i=0; i<(klen-1); i++) 
				fprintf(stream,"%02hhx ",k->K[i]);
			    fprintf(stream,"%02hhx",k->K[i]);
			} else fprintf(stream,"x");
			    
			break;
		    case 'K' : //key sums
			if (klen) {
			    tot=0;
			    for (i=0; i<(klen-1); i++) {
				tot+=k->K[i];
				fprintf(stream,"%02hhx ",tot);
			    }
			    tot+=k->K[i];
			    fprintf(stream,"%02hhx",tot);
			} else fprintf(stream,"X");
			break;
		    case 'g' : 
			fprintf(stream,"%f",k->gr);
			break;
		    case 'l' : //klen
			fprintf(stream,"%hhu",klen);
			break;
		    case 'c' : //position
			fprintf(stream,"%hhu",k->clen);
			break;
		}
	    }
	}
    }
    fprintf(stream,s0);
}

/* return 0.0f if equal, else grows up */
Grade diff_key(const struct key *k1,const struct key *k2)
{
    size_t i,klen;
    Grade g,f;

    assert(k1->klen==k2->klen);
    
    klen=k1->klen;
    g=0.0f;
    f=1.0f;
    for (i=0; i<klen; i++) {
	if (k1->K[i]!=k2->K[i]) g+=f;
	f*=DIFF_KEY_COEFF;
    }
    return g;
}


/* guess related functions */

void reset_guess(guess_cnt_t g)
{
    memset(g,0,sizeof(guess_cnt_t));
}




void est_guess(struct key *K,guess_cnt_t gc,guess_stat_t gs)
{
    
    size_t i,j;

    for (i=0;i<256;i++) {
	gs[i]=0.0f;
	for (j=0;j<N_ATTACKS;j++) gs[i]+=cf1[j]*gc[i][j];


	if (K->clen >= K->klen) {
	    switch (gc[i][A_neg]/2) {
		case 0:
		    break;
		case 1:
		    gs[i]-=1.0f;
		    break;
		case 2:
		    gs[i]-=3.0f;
		    break;
		case 3:
		    gs[i]-=6.0f;
		    break;
		default:
		    /* aka minus infinity */
		    gs[i]=M_INF;
	    }
	}
	else {
	    switch (gc[i][A_neg]) {
		case 0:
		    break;
		case 1:
		    gs[i]-=1.0f;
		    break;
		case 2:
		    gs[i]-=3.0f;
		    break;
		case 3:
		    gs[i]-=6.0f;
		    break;
		default:
		    /* aka minus infinity */
		    gs[i]=M_INF;
	    }
	}
    } 
    if (gs[i]>1.5f) gs[i]+=1.9f*gc[i][A_w15];
    else gs[i]+=1.4f*gc[i][A_w15];

    return ;
}

/* retains the two top value, then normalize to 1 if possible 
   Note this one fails if no lead are found 
   Better yet, take the max, divide by 6 , and substract! */
void adj_guess(guess_stat_t gs)
{
    Grade max,br,s;
    size_t i,cnt;

    max=M_INF;
    /* get max */
    for (i=0;i<256;i++) max=(gs[i]>max) ? gs[i] : max;
    
    
    if (max>0.0f) {
	/* br is a threshold */
	br=max/DIV_F;
	s=0.0f;
	cnt=0;
	for (i=0;i<256;i++) {
	    if (gs[i]<br) {
		gs[i]=M_INF;
	    }
	    else {
		cnt++;
		/* normalize to 1 */
		gs[i]=(gs[i]-br)/(max-br);
		s+=gs[i];
	    }
	}
	
	/* second normalization if there are too many guesses ? */
	for (i=0;i<256;i++) 
	    if (gs[i]>=0) gs[i]/=s;

    }
    /* weed out */
    else if (max<=0.0f) {
	for (i=0; i<256; i++) {
	    if (gs[i]<max) gs[i]=M_INF;
	}
    }    
    return;	
}

/* old version */
/* void adj_guess_2(guess_stat_t gs) */
/* { */
/*     Grade g1,g2; */
/*     u_char s1[256],s2[256]; */
/*     u_char *l1,*l2,*swp; */
/*     size_t N1,N2,sw,i; */

/*     g1=0.0f; */
/*     g2=-1.0f; */
/*     N1=0; */
/*     N2=0; */
/*     s1=l1; */
/*     s2=l2; */
/*     for (i=0; i<256; i++) { */
/* 	if (gs[i]>g1) { */
/* 	    g2=g1; */
/* 	    N2=N1; */
/* 	    swp=s2; */
/* 	    s2=s1; */
/* 	    s1=swp */
/* 	    g1=gs[i]; */
/* 	    N1=1; */
/* 	    s1[0]=i; */
/* 	} */
/* 	else if (gs[i]==g1) { */
/* 	    s1[N1++]=i; */
/* 	} */
/* 	else if (gs[i]>g2) { */
/* 	    g2=gs[i]; */
/* 	    N2=1; */
/* 	    s2[0]=i; */
/* 	} */
/* 	else if (gs[i]==g2) { */
/* 	    s2[N2++]=i; */
/* 	} */
/*     } */

/*     for (i=0; i<256; i++) gs[i]=M_INF; */
/*     for (i=0; i<N1; i++) gs[s1[i]]=1.0; */
    
/*     if ((2.5f*g2) > g1) { */
/* 	/\* then we have g1>0.0f and g2>=0.0f *\/ */
/* 	for (i=0; i<N2; i++) gs[s2[i]]=g2/g1; */
/*     } */
/*     return; */
/* } */
/* Grade max_guess(guess_stat_t gs) */
/* { */
/*     size_t i,maxi; */
/*     Grade maxf; */
    
/*     maxf=-200.0f; */
/*     for (i=0; i<256; i++) { */
/* 	if (gs[i]>maxf) { */
/* 	    maxf=gs[i]; */
/* 	    maxi=i; */
/* 	} */
/*     } */
/*     return maxi; */
/* } */


/* initialize S (ie try a version with a static cache & memcpy  */
void initS(u_char *Sc)
{
    u_int v;
    size_t i;
    u_int *S=(u_int *)Sc;

    v=0x03020100;
    for (i=0; i<64; i++) {
	S[i]=v; 
	v+=0x04040404;
    }
}


void print_counters(guess_cnt_t g,guess_stat_t gs)
{
    size_t i,j;
    for (i=0; i<256; i++) {
	printf("%02x : ",i);
	for (j=0; j<N_ATTACKS; j++) printf("%3hu:",g[i][j]);
	printf("%4f\n",gs[i]);
    }
    fflush(stdout);
}


void plain_attack(struct wep_data *w,struct key *K0,guess_cnt_t g)
{
    size_t cnt,n_samples,sample_size;
    u_char *s;

    u_char S[256],Si[256],j[256],K[32];
    size_t klen,round;

    size_t r,i,iK;

    u_char tmp_j;
    u_char io1,o1,io2,o2;
    u_char Sq,dq,Kq,jq,q;
    u_char J1,J2,S2,t2;


    sample_size=w->sample_size;
    n_samples=w->n_samples;
    s=w->sample;

    /* disturbing thing is that clen sometimes reflect the 
       length of the key, and sometime does not */
    if (K0->klen==0) {
	klen=K0->clen+3;
	round=0;
	q=klen;
    }
    else {
	klen=K0->klen+3;
	round=K0->clen/K0->klen;
	q=klen*round+3+(K0->clen % K0->klen);
    }
    memcpy(K+3,K0->K,klen-3);

    for (cnt=0; cnt<n_samples; cnt++, s+=sample_size) {
	initS(S);
	initS(Si);
	
	K[0]=s[0];
	K[1]=s[1];
	K[2]=s[2];

	tmp_j=0;
	i=0;
	for (r=0; r<round; r++) {
	    for (iK=0; iK<klen; iK++, i++) {
		tmp_j+=K[iK]+S[i];
		j[i]=tmp_j;
		swap(S+i,S+tmp_j);
	    }
	}
	for (iK=0; i<q; i++, iK++) {
	    tmp_j+=K[iK]+S[i];
	    j[i]=tmp_j;
	    swap(S+i,S+tmp_j);
	}

	i=q;
	do {
	    i--;
	    swap(Si+i,Si+j[i]);
	} while (i!=0);


	o1=s[3];
	o2=s[4];

	io1=Si[o1];
	io2=Si[o2];

	Sq=S[q];
	dq=Sq+j[q-1];
	J1=S[1];
	S2=S[2];

	/* o2=0 related */
	if (S2==0) {
	    if ((J1==2) && (o1==2)) {
		// jq is quite probably not 1 nor 2
		Kq=1-dq;
		g[Kq][A_neg]++;
		Kq=2-dq;
		g[Kq][A_neg]++;
	    }
	    else if (o2==0) { 
		// jq is quite probably not 2
		Kq=2-dq;
		g[Kq][A_neg]++;
	    }
	}
	else {
	    if ((o2==0) && (Sq==0)) {
		Kq=2-dq;
		g[Kq][A_w15]++;
	    }
	}

	/* mowing out S(1)=1, o_1=S(2) */
	if ((J1==1) && (o1==S2)) {
	    Kq=1-dq;
	    g[Kq][A_neg]++;
	    Kq=2-dq;
	    g[Kq][A_neg]++;
	}

	/* mowing out S(1)=0, S(0)=1, o_1=1 */
	if ((J1==0) && (S[0]==1) && (o1==1)) {
	    Kq=-dq;
	    g[Kq][A_neg]++;
	    Kq=1-dq;
	    g[Kq][A_neg]++;
	}

	if (J1==q) {
	    if (o1==q) {
		/* strong 13: S(1)=q,S(q)=0,o_1=q */
		Kq=Si[0]-dq;
		g[Kq][A_s13]++;
	    }
	    else if (((1-q-o1) & 0xff) == 0) {
		/* semi-weak 13% S(1)=q,S(q)=1-q,o_1=1-q */
		Kq=io1-dq;
		g[Kq][A_w13_1]++;
	    } else if (io1<q) {
		/* weak 5%: S(q)+q=io1<q, note io1!=1,ie o1!=q  */
		jq=Si[(io1-q) & 0xff];
		if (jq!=1) {
		    Kq=jq-dq;
		    g[Kq][A_w5_1]++;
		}
	    } 
	}

	if ((io1==2) && (S[q]==1)) {
	    /* one overlapping case with A_w5_1 (J1=q,S[q]=1,io1=2) */
	    Kq=1-dq;
	    g[Kq][A_w5_2]++;
	}

	if (S[q]==q) {
	    if ((J1==0) && (o1==q)) {
		/* weak 13%: S'(1)=0, S'(q)=q and j_q=1 then 
		   1->q->0 hence o1=q */
		Kq=1-dq;
		g[Kq][A_w13_2]++;
	    }
	    else if ((((1-q-J1) & 0xff)==0) && (o1==J1)) {
		/* weak 13%: S'(1)=1-q, S'(q)=q and j_q=1 then
		   1->q->1-q hence o1=1-q */
		Kq=1-dq;
		g[Kq][A_w13_3]++;
	    }
	    else if ((J1 >= ((-q) & 0xff)) && (((q+J1-io1)&0xff)==0)) {
		/* weak 5%: jq=1, Sq=q, J1!=0,1-q */
		Kq=1-dq;
		g[Kq][A_w5_3]++;
	    }
	}

 	/* half-strong 5%s (ie strong 5 and some weak 5)*/
	if ((J1 < q) && (((J1+S[J1]-q)&0xff) == 0) &&
	    (io1!=1) && (io1!=S[J1])) {
	    Kq=io1-dq;
	    g[Kq][A_s5_1]++;
	}

	/* strong 5% attack on o_2  */
	/* S1>q, S1+S2=q, S(q)=S1-S2,2-S2 (1,2 not touched), J2=q, t2=S1,2 o2=S1,Sq */
	/* if J1=2, does not work */
	/* if J1=q,S2=0 does not work/already treated? */
	/* are some of the cases excluded predictable? */
	if ((J1 > q) && (((S2+J1-q)&0xff) == 0)) {
	    if (o2==J1) {
		jq=Si[J1-S2];
		if ((jq!=1) && (jq!=2)) {
		    Kq=jq-dq;
		    g[Kq][A_s5_2]++;
		}
	    }
	    else if (o2==(2-S2)) {
		jq=io2;		    
		if ((jq!=1) && (jq!=2)) {
		    Kq=jq-dq;
		    g[Kq][A_s5_3]++;
		}
	    }
	}

	/* 3% attack on second byte */
	if ((S[1]!=2) && (S[2]!=0)) {
	    J2=S[1]+S[2];
	    if (J2<q) {
		t2=S[J2]+S[2];
		if ((t2==q) && (io2!=1) && (io2!=2) && (io2!=J2)) {
		    Kq=io2-dq;
		    g[Kq][A_s2]++;
		}
	    }
	}

	/* special case q=4,J1=2, then J2=4, t2=S[4]+2 */
	if (J1==2) {
	    if (q==4) {
		if (o2==0) {
		    /* S(4)=0 */
		    Kq=Si[0]-dq;
		    g[Kq][A_4_s13]++;
		} else {
		    if (j[1]==2) { // for stability reasons
			switch (io2) {
			    case 0: 
				Kq=Si[254]-dq;
				g[Kq][A_4_w5_1]++;
				break;
			    case 2: 
				Kq=Si[255]-dq;
				g[Kq][A_4_w5_2]++;
				break;
			 /* case 3: has to be avoided. Why is there a big 
			        aggregate 
				Kq=Si[1]-dq;
				g[Kq][A_4_w5_3]++;
				break; */
			}
		    }
		}
	    }
	    else if ((q>4U) && ((S[4]+2)==q) && 
		     (io2!=1) && (io2!=4)) {
		/* o2=S(1,2)(2,4)(q)=S(q)=S_{q-1}(j_q) */
		Kq=io2-dq;
		g[Kq][A_w5_4]++;
	
	    }
	}
    }
}

/* This attack only works if we are on the last byte of the key K[clen]. 
   (make sense only if either clen=klen-1 or klen=0)
   Since IV[0] is the first byte of the key, we can deduce j[clen] from 
   j[clen+1]. Is an extension to IV[1] worth it? 
*/
void attack_last(struct wep_data *w,struct key *K0,guess_cnt_t g)
{
    size_t cnt,n_samples,sample_size;
    u_char *s;

    u_char S[256],Si[256],j[256],K[32];
    size_t klen,round;

    size_t r,i;

    u_char tmp_j;
    u_char io1,o1,io2,o2;
    u_char Sq,Sq1,dq1,dq,Kq,jq,q;
    u_char J1,J2,S2,t2;


    sample_size=w->sample_size;
    n_samples=w->n_samples;
    s=w->sample;

    if (K0->klen==0) {
	klen=K0->clen+3;
	round=0;
	q=klen;
    }
    else {
	klen=K0->klen+3;
	round=K0->clen/K0->klen;
	q=klen*round+3+(K0->clen % K0->klen);
    }
    if (round != 0) {
	fprintf(stderr,"attack_last called with round != 0\n");
	exit(1);
    }

    memcpy(K+3,K0->K,klen-3);

    for (cnt=0; cnt<n_samples; cnt++, s+=sample_size) {
	initS(S);
	initS(Si);
	
	K[0]=s[0];
	K[1]=s[1];
	K[2]=s[2];

	tmp_j=0;
	for (i=0; i<q; i++) {
	    tmp_j+=K[i]+S[i];
	    j[i]=tmp_j;
	    swap(S+i,S+tmp_j);
	}

	i=q;
	do {
	    i--;
	    swap(Si+i,Si+j[i]);
	} while (i!=0);


	o1=s[3];
	o2=s[4];

	io1=Si[o1];
	io2=Si[o2];

	Sq=S[q];
	Sq1=S[q+1];
	dq=Sq+j[q-1];
	dq1=Sq+Sq1+j[q-1]+K[0];
	J1=S[1];
	S2=S[2];

	/* o2=0 related */
	if (S2==0) {
	    if ((J1==2) && (o1==2)) {
		// j[q] is quite probably not 1 nor 2
		Kq=1-dq;
		g[Kq][A_neg]++;
		Kq=2-dq;
		g[Kq][A_neg]++;

		// j[q+1] is quite probably not 1 nor 2
		jq=1-Sq1-K[0];
		if ((jq != q+1) && (jq != 1) && (jq != 2)) {
		    Kq=jq-dq;
		    g[Kq][A_neg]++;
		}
		
		jq=2-Sq1-K[0];
		if ((jq != q+1) && (jq != 1) && (jq != 2)) {
		    Kq=jq-dq;
		    g[Kq][A_neg]++;
		}
	    }
	    else if (o2==0) { 
		// j[q] is quite probably not 2
		Kq=2-dq;
		g[Kq][A_neg]++;

		// same goes for j[q+1], ie j[q]!=2-S[q+1]-K[0]
		jq=2-Sq1-K[0];
		if ((jq != q+1) && (jq != 1) && (jq != 2)) {
		    Kq=jq-dq;
		    g[Kq][A_neg]++;
		}		
	    }

	}
	else if ((o2==0) && (Sq==0)) {
	    // j[q] is 2 with probability 18% (unstable)
	    Kq=2-dq;
	    g[Kq][A_w15]++;
	} 
	else if ((o2==0) && (Sq1=0)) {
	    // j[q+1] is 2 with probability 18%
	    jq=2-Sq1-K[0];
	    if (jq != q+1) {
		Kq=jq-dq;
		g[Kq][A_w15]++;
	    }
	}

	/* mowing out S(1)=1, o_1=S(2) */
	if ((J1==1) && (o1==S2)) {
	    // j[q] is probably not 1 nor 2
	    Kq=1-dq;
	    g[Kq][A_neg]++;
	    Kq=2-dq;
	    g[Kq][A_neg]++;

	    // j[q+1] is probably not 1 nor 2
	    jq=1-Sq1-K[0];
	    if ((jq != q+1) && (jq != 1) && (jq != 2)) {
		Kq=jq-dq;
		g[Kq][A_neg]++;
	    }
	    
	    jq=2-Sq1-K[0];
	    if ((jq != q+1) && (jq != 1) && (jq != 2)) {
		Kq=jq-dq;
		g[Kq][A_neg]++;
	    }
	}

	/* mowing out S(1)=0, S(0)=1, o_1=1 */
	if ((J1==0) && (S[0]==1) && (o1==1)) {
	    // j[q] is probably not 0 or 1
	    Kq=-dq;
	    g[Kq][A_neg]++;
	    Kq=1-dq;
	    g[Kq][A_neg]++;

	    // j[q+1] is probably not 0 or 1
	    jq=-Sq1-K[0];
	    if ((jq != q+1) && (jq != 0) && (jq != 1)) {
		Kq=jq-dq;
		g[Kq][A_neg]++;
	    }
	    
	    jq=1-Sq1-K[0];
	    if ((jq != q+1) && (jq != 0) && (jq != 1)) {
		Kq=jq-dq;
		g[Kq][A_neg]++;
	    }
	}


	if (J1 == q) {
	    if (o1 == q) {
		/* strong 13: S(1)=q,S(q)=0,o_1=q / S'[j[q]]=0 */
		Kq=Si[0]-dq;
		g[Kq][A_s13]++;
	    }
	    else if (((1-q-o1) & 0xff) == 0) {
		/* semi-weak 13% S(1)=q,S(q)=1-q,o_1=1-q */
		Kq=io1-dq;
		g[Kq][A_w13_1]++;
	    } 
	    else if (io1<q) {
		/* weak 5%: S(q)+q=io1<q, note io1!=1,ie o1!=q  */
		jq=Si[(io1-q) & 0xff];
		if (jq!=1) {
		    Kq=jq-dq;
		    g[Kq][A_w5_1]++;
		}
	    } 
	}

	if (J1 == q+1) {
	    if (o1 == q+1) {
		// strong 13, S'[j[q+1]]=0
		jq=Si[0]-Sq1-K[0];
		if ((jq != q+1) && (jq != Si[0])) {
		    Kq=jq-dq;
		    g[Kq][A_s13]++;
		}
	    }
	    else if (((q+o1) & 0xff) == 0) {
		// semi weak 13: S'[j[q+1]]=1 
		jq=io1-Sq1-K[0];
		if ((jq != q+1) && (jq != io1)) {
		    Kq=jq-dq;
		    g[Kq][A_w13_1]++;
		}
	    }
	    //drop the weak 5%;
	}
		

	if ((io1==2) && (S[q]==1)) {
	    /* one overlapping case with A_w5_1 (J1=q,S[q]=1,io1=2) */
	    Kq=1-dq;
	    g[Kq][A_w5_2]++;
	}

	if ((io1==2) && (S[q+1]==1)) {
	    // j[q+1]=1
	    jq=1-Sq1-K[0];
	    if (jq != q+1) {
		Kq=jq-dq;
		g[Kq][A_w5_2]++;
	    }
	}



	if (S[q]==q) {
	    if ((J1==0) && (o1==q)) {
		/* weak 13%: S'(1)=0, S'(q)=q and j_q=1 then 
		   1->q->0 hence o1=q */
		Kq=1-dq;
		g[Kq][A_w13_2]++;
	    }
	    else if ((((1-q-J1) & 0xff)==0) && (o1==J1)) {
		/* weak 13%: S'(1)=1-q, S'(q)=q and j_q=1 then
		   1->q->1-q hence o1=1-q */
		Kq=1-dq;
		g[Kq][A_w13_3]++;
	    }
	    else if ((J1 >= ((-q) & 0xff)) && (((q+J1-io1)&0xff)==0)) {
		/* weak 5%: jq=1, Sq=q, J1!=0,1-q */
		Kq=1-dq;
		g[Kq][A_w5_3]++;
	    }
	}

	if (S[q+1] == q+1) {
	    if ((J1 == 0) && (o1 == q+1)) {
		/* j[q+1]=1 */
		jq=1-Sq1-K[0];
		if ((jq != 1) && (jq != q+1)) {
		    Kq=jq-dq;
		    g[Kq][A_w13_2]++;
		}
	    }
	    else if ((((q+J1) & 0xff) == 0) && (o1==J1)) {
		/* j[q+1]=1 */
		jq=1-Sq1-K[0];
		if ((jq != 1) && (jq != q+1)) {
		    Kq=jq-dq;
		    g[Kq][A_w13_2]++;
		}
	    } 
	    // drop last one
	}

 	/* half-strong 5%s (ie strong 5 and some weak 5)*/
	if ((J1 < q) && (((J1+S[J1]-q)&0xff) == 0) &&
	    (io1!=1) && (io1!=S[J1])) {
	    Kq=io1-dq;
	    g[Kq][A_s5_1]++;
	}


	if ((J1 < q) && (((J1+S[J1]-q-1)&0xff) == 0) &&
	    (io1!=1) && (io1!=S[J1])) {
	    jq=io1-Sq1-K[0];
	    if ((j[q] != q+1) && (j[q] != 1) && (j[q] != J1)) {
		Kq=jq-dq;
		g[Kq][A_s5_1]++;
	    }
	}



	/* strong 5% attack on o_2  */
	/* S1>q, S1+S2=q, S(q)=S1-S2,2-S2 (1,2 not touched), */
	/* J2=q, t2=S1,2 o2=S1,Sq */
	/* if J1=2, does not work */
	/* if J1=q,S2=0 does not work/already treated? */
	/* are some of the cases excluded predictable? */
	if ((J1 > q) && (((S2+J1-q)&0xff) == 0)) {
	    if (o2==J1) {
		jq=Si[J1-S2];
		if ((jq!=1) && (jq!=2)) {
		    Kq=jq-dq;
		    g[Kq][A_s5_2]++;
		}
	    }
	    else if (o2==(2-S2)) {
		jq=io2;		    
		if ((jq!=1) && (jq!=2)) {
		    Kq=jq-dq;
		    g[Kq][A_s5_3]++;
		}
	    }
	}
	// dropped

	/* 3% attack on second byte */
	if ((S[1]!=2) && (S[2]!=0)) {
	    J2=S[1]+S[2];
	    if (J2<q) {
		t2=S[J2]+S[2];
		if ((t2==q) && (io2!=1) && (io2!=2) && (io2!=J2)) {
		    Kq=io2-dq;
		    g[Kq][A_s2]++;
		}
	    }
	}

    }
    for (i=0; i<256; i++) {
	g[i][A_neg]/=2;
    }
}






Grade check_key(struct wep_data *w,struct key *k,size_t inc)
{
    size_t cnt,n_samples,inc_sample_size;
    u_char *s;

    u_char S[256],K[32];
    size_t klen;

    size_t i,iK;
    u_char j,t;
    size_t suc,tot;


    inc_sample_size=w->sample_size*inc;
    n_samples=w->n_samples;
    s=w->sample;

    klen=k->klen+3;
    memcpy(K+3,k->K,klen-3);
    
    tot=0;
    suc=0;

    for (cnt=0; cnt<n_samples; cnt+=inc, s+=inc_sample_size) {
	initS(S);
	
	K[0]=s[0];
	K[1]=s[1];
	K[2]=s[2];

	
	for (i=0,iK=0,j=0; i<256; i++,iK++) {
	    if (iK==klen) iK=0;
	    j=(j+K[iK]+S[i]) & 0xff;
	    swap(S+i,S+j);
	}
	
	j=S[1];
	t=S[j]+S[1];
	swap(S+1,S+j);
	if (S[t]==s[3]) suc++;

	j+=S[2];
	t=S[j]+S[2];
	swap(S+2,S+j);
	if (S[t]==s[4]) suc++;

	tot++;
    }
    
    return suc/(2.0f*tot);
}
