/* gen.c

   Author : KoreK
   Date : Mar 8,2004
   Licence : GPL v2 or above (see accompanying LICENSE file)
*/

#ifndef GEN_H
#define GEN_H

#include "rg.h"

#define LIMIT (1<<22)

/* Error codes 
 */

#define WEP_MAGIC 0x523fc3a4
#define RAW_MAGIC 0x4d3c0f10
#define TOOMANYIVS 1
#define ERRALLOC 2
#define NOKEY 3
#define NOIV 4
#define INVPAR 5


/* you should always call init_wepdata after creating , even if it's to 
   zero its coeff */
int init_wepdata(struct wep_data *w,size_t n_samples,size_t key_len,
		 unsigned char *K,unsigned int p,unsigned int J_present);

int set_random_key(struct wep_data *w,struct random_gen *r);

int allIV(struct wep_data *w);

int fillIV(struct wep_data *w,struct random_gen *r);

void delete_wepdata(struct wep_data *w);


int read_wep(struct wep_data *w,const char *fn);
int write_wep(struct wep_data *w,const char *fn);



void delete_tables(struct wep_data *w);
void delete_reson_idx(struct wep_data *w);



#endif
