/* wep_data.h

   Author : KoreK
   Date : Mar 8,2004
   Licence : GPL v2 or above (see accompanying LICENSE file)
*/


/* n_samples is the number of samples
   n_fields is the width in bytes of a sample i.e (1+J_given)*p+3
   sample is the wep data organized as followed: 
   j_0,j_1,j_2,o_1,...,o_p,J_1,...,J_p 
   key is a pointer to NULL if key is not given (key_len=0)
   or array of key_len elts else

   key_table: array of 256 (a,b,p,j_3(p),...) where 1->a->b 
   weakness means that b != 1
*/

#ifndef WEP_DATA_H
#define WEP_DATA_H
   
struct wep_data {
    size_t n_samples,sample_size;
    unsigned char *sample;
    unsigned char *key;

#ifdef ANONYMOUS_STRUCT
    struct {
	unsigned int p:8;
	unsigned int key_len:8;
	unsigned int J_present:1;
	unsigned int pad:15;
    };
#else
    unsigned int p;
    unsigned int key_len;
    unsigned int J_present;
#endif

    short int (*j_table)[256];
    unsigned char (*S_table)[256];
    
    float *res_i;
    
};

typedef struct wep_data wep_data_t[1];

#endif
